Components.utils.import("resource://profilepassword-modules/main.js")

PPlock = {

	stopmousekey : function(evt) {
		if (evt.target.id == "unlocklink" && evt.type == "click" && ProfilePasswordMain.getPrompt(null)) {
			top.removeEventListener("mouseup", PPlock.stopmousekey, true);
			top.removeEventListener("mousedown", PPlock.stopmousekey, true);
			top.removeEventListener("click", PPlock.stopmousekey, true);
			top.removeEventListener("keypress", PPlock.stopmousekey, true);
			top.removeEventListener("popupshowing", PPlock.stopmousekey, true);	
			PPlock.unblockwindow();	
		}
		evt.stopPropagation();
		evt.preventDefault();			
	},

	disablebuttons : function() {
		var buttons = document.getElementsByTagName("toolbarbutton");
		for (i=0; i<buttons.length;i++) {
			if (! ((buttons[i].id == "ierbutton") || (buttons[i].id == "button-getmsg")) ) {
				if (buttons[i].disabled == false) {
					buttons[i].disabled = true;
					buttons[i].setAttribute("ppcheck", "true");
				}
			}
		}
	},

	// Riabilita i bottoni che hanno l'attributo "ppcheck=true", il che vuol dire che sono stati
	// disabilitati prima dall'estensione
	enablebuttons : function() {
		var buttons = top.document.getElementsByTagName("toolbarbutton");
		for (var i=0; i<buttons.length;i++) {
			if (buttons[i].getAttribute("ppcheck")) {
				buttons[i].disabled = false;
				buttons[i].removeAttribute("ppcheck");
			}
		}
	},

	// Blocca gli elementi della finestra principale
	blockwindow : function() {
		GetThreadTree().collapsed = true;
		GetMessagePane().collapsed = true;
		PPlock.disablebuttons();
		document.getElementById("accountCentralBox").collapsed = false;
		try {  
			ShowingAccountCentral();
		}
		catch(e) {
			document.getElementById("messagepaneboxwrapper").collapsed = true;
		}
		var tabmail = document.getElementById("tabmail");  
		if (tabmail) {
			tabmail.tabContainer.selectedIndex = 0;
			document.getElementById("messagepanebox").collapsed = true;
		}
		document.getElementById("displayDeck").selectedPanel = document.getElementById("accountCentralBox");
		window.frames["accountCentralPane"].location.href = "chrome://profilepass/content/lockwindow.xul";
		// Blocca i click del mouse e la tastiera
		window.addEventListener("mousedown", PPlock.stopmousekey, true);
		window.addEventListener("mouseup", PPlock.stopmousekey, true);
   		window.addEventListener("click", PPlock.stopmousekey, true);
		window.addEventListener("keypress", PPlock.stopmousekey, true);
		window.addEventListener("popupshowing", PPlock.stopmousekey, true);
		// top.ProfilePasswordMain.lockOn = true;
		// top.lockOn = true;
		PPlock.isOnLine = MailOfflineMgr.isOnline();
		if (PPlock.isOnLine && ProfilePasswordMain.prefs.getBoolPref("extensions.profilepassword.auto_offline")) {
			var offlineManager = Components.classes["@mozilla.org/messenger/offline-manager;1"]                 
        	                .getService(Components.interfaces.nsIMsgOfflineManager);
			offlineManager.synchronizeForOffline(false, false, false, true, msgWindow);
		}
	},

	unblockwindow : function() {
		if (top.document.getElementById("messagepane"))
			top.document.getElementById("messagepane").collapsed = false;
		if (document.getElementById("messagepanebox").collapsed)
			document.getElementById("messagepanebox").collapsed = false;
		top.frames["accountCentralPane"].location.href =  "chrome://messenger/content/msgAccountCentral.xul"
		top.document.getElementById("threadTree").collapsed = false;
		PPlock.enablebuttons();
		top.ProfilePasswordMain.lockOn = false;
		top.lockOn = false;
		top.document.title = "Mozilla Thunderbird";
		if (PPlock.isOnLine && ProfilePasswordMain.prefs.getBoolPref("extensions.profilepassword.auto_offline")) {
			var offlineManager = Components.classes["@mozilla.org/messenger/offline-manager;1"]                 
        		        .getService(Components.interfaces.nsIMsgOfflineManager);
			offlineManager.goOnline(false, false, msgWindow);
			PPlock.isOnLine = false;
		}
	},

	lockScreen : function() {
		if (ProfilePasswordMain.prefs.getPrefType("extensions.profilepassword.magic_hex_number") == 0  
		//   || (ProfilePasswordMain.prefs.getBoolPref("profilepassword.use_master_password") && PPlock.checkNullMasterPassword()) 
		) {
			alert(ProfilePasswordMain.bundle.GetStringFromName("nopass"));
			return;
		}
		PPlock.blockwindow();
	}
};
