Components.utils.import("resource://profilepassword-modules/main.js");
var currentPwd;

function onLoad() {
	document.getElementById("minlenBox").value = ProfilePasswordMain.prefs.getIntPref("extensions.profilepassword.min_length");
	document.getElementById("prefpassDialog").getButton("accept").setAttribute("disabled", "true");
	currentPwd = ProfilePasswordMain.getPassword();
}

// Encode password
function setPassword() {
	var string1 ="";
	var passwd = document.getElementById("profpass").value;
	for (var i=0; i<passwd.length ;i=i+1) 	{
		var string2 = passwd.charCodeAt(i).toString(16);
		string1 = string1 + string2;
        }
	var enc = (passwd.charCodeAt(1)-6).toString(16) +  (passwd.charCodeAt(1)-10).toString(16);
	return (enc + string1);
}


function checkpwd() {
	if  (currentPwd) {
		if ( document.getElementById("profpass3").value != currentPwd) {
			alert(ProfilePasswordMain.bundle.GetStringFromName("wrongoldpass"));
			document.getElementById("profpass").value = "";
			document.getElementById("profpass2").value = "";
			document.getElementById("profpass3").value = "";
			return false;
		}
	}
	if ( document.getElementById("profpass").value != document.getElementById("profpass2").value ) {
		alert(ProfilePasswordMain.bundle.GetStringFromName("errorwritepass"));
		document.getElementById("profpass").value = "";
		document.getElementById("profpass2").value = "";
		document.getElementById("profpass3").value = "";
		return false;
	}
	return true;
}

function testpwd() { 
	var minlen = document.getElementById("minlenBox").value;
	var ok = true;
	if ((currentPwd && currentPwd.length < minlen) || (document.getElementById("profpass").value.length > 0 && document.getElementById("profpass").value.length < minlen)) {
		alert(ProfilePasswordMain.bundle.GetStringFromName("passtooshort"));
		document.getElementById("profpass").value = "";
		document.getElementById("profpass2").value = "";
		ok = false
	}
	if (document.getElementById("profpass").value.search(/[^a-zA-Z0-9_]/) != -1) {
		alert(ProfilePasswordMain.bundle.GetStringFromName("badchars"));
		document.getElementById("profpass").value = "";
		document.getElementById("profpass2").value = "";
		ok = false;
	}
	return ok;
}
			
function setchange() {
	document.getElementById("pass1").removeAttribute("collapsed");
	document.getElementById("confirm").removeAttribute("collapsed");
	if (ProfilePasswordMain.prefs.getPrefType("extensions.profilepassword.magic_hex_number") >0) 
		document.getElementById("oldpass").removeAttribute("collapsed");
	document.getElementById("prefpassDialog").getButton("accept").removeAttribute("disabled");
	window.sizeToContent();
	document.getElementById("changepass").setAttribute("disabled", "true");
	document.getElementById("profpass").focus();
}	

function onOK() {
	ProfilePasswordMain.prefs.setIntPref("extensions.profilepassword.min_length", document.getElementById("minlenBox").value);
	var passChanged =  (document.getElementById("pass1").getAttribute("collapsed") != "true");
	var ok = testpwd();
	if (! ok)
		return false;
	if (! passChanged)
		return true;
	var ret = checkpwd();
	if (ret) {
		if (document.getElementById("profpass").value.length != 0) {
			ProfilePasswordMain.prefs.setCharPref("extensions.profilepassword.magic_hex_number", setPassword());
		}
		else {
			ProfilePasswordMain.prefs.deleteBranch("extensions.profilepassword.magic_hex_number");
		}
	}
	return ret;
}
