Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
Components.utils.import("resource://profilepassword-modules/main.js");

// class declaration
function ProfilePassword() {}

ProfilePassword.prototype = {
    classDescription: "ProfilePassword Extension",
    classID:          Components.ID("{0659c94d-bed3-4711-8870-d1547695baec}"),
    contractID:       "@kaosmos.nnp/profilepassword;1",
     // add to category manager
    _xpcom_categories: [{
        category: "profile-after-change"
    }],

   QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIObserver]), observe: function(subject, topic, data) {
		if (topic === "profile-after-change") {	
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  			observerService.addObserver(ProfilePassword.obs, "domwindowopened", false);
		}
      }
};

ProfilePassword.obs = {
	observe: function(subject, topic, data) {
		var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
 		// observerService.removeObserver(ProfilePassword.obs, "domwindowopened");
		var win = subject;
		win.addEventListener("load", function() {
			if (win.location.href.indexOf("commonDialog.xul") > -1)
				return;
			if (! ProfilePasswordMain.unlocked) 
				ProfilePasswordMain.start(win);
			if (ProfilePasswordMain.lockOn)
				win.close();	
		}, false);
	}
};

var NSGetFactory = XPCOMUtils.generateNSGetFactory([ProfilePassword]);  // Gecko 2.0+


